module dmd.InlineCostState;

import dmd.FuncDeclaration;
import dmd.Array;
import dmd.Expression;

struct InlineCostState
{
    int nested;
    int hasthis;
    int hdrscan;    // !=0 if inline scan for 'header' content
    FuncDeclaration fd;
}

const int COST_MAX = 250;

int arrayInlineCost(InlineCostState* ics, Array arguments)
{
	int cost = 0;

    if (arguments)
    {
		for (int i = 0; i < arguments.dim; i++)
		{   
			Expression e = cast(Expression)arguments.data[i];
			if (e)
				cost += e.inlineCost(ics);
		}
    }
    return cost;
}